////////////////////////////////////////////////////////////////////////////////
/// @file
/// @brief VNCコマンド関連のソース
///
/// 外部VNCソフトウェアを操作する際に利用されます。
///
/// Copyright (C) 2009 Alpha Systems Inc. All Rights Reserved.
/// @internal
/// @date $Date: $
/// @version $Revision: $
////////////////////////////////////////////////////////////////////////////////

#include "vncviewer.h"

/* VNCサーバ起動 */
void
StartVNCServer()
{
  //ユーザーモード
  //RealVNCユーザーモードで起動
//  char vncserver_cmd[32] = "winvnc4";
  //TightVNCユーザーモードで起動
//  char vncserver_cmd[32] = "winvnc";
  //UltraVNCユーザーモードで起動
  char vncserver_cmd[32] = "winvnc";
  //サービスモード
  //RealVNCサービスモードで起動
//  char vncserver_cmd[32] = "winvnc4 -start";
  //TightVNCサービスモードで起動
//  char vncserver_cmd[32] = "winvnc -service";
  //UltraVNCサービスモードで起動
//  char vncserver_cmd[32] = "winvnc -startservice";

  runCommand(vncserver_cmd, 0, NULL);
}

/* VNCサーバ終了 */
void
CloseVNCServer()
{
  //Windows版VNC終了
  //RealVNCユーザーモード終了
//  char vncserver_cmd[32] = "taskkill /F /IM winvnc4.exe";
  //TightVNCユーザーモード終了
//  char vncserver_cmd[32] = "winvnc -kill";
  //UltraVNCユーザーモード終了
  char vncserver_cmd[32] = "winvnc -kill";
  //RealVNCサービスモード終了
//  char vncserver_cmd[32] = "winvnc4 -stop";
  //TightVNCサービスモード終了
//  char vncserver_cmd[32] = "winvnc -reload";
  //UltraVNCサービスモード終了
//  char vncserver_cmd[32] = "winvnc -stopservice";

  runCommand(vncserver_cmd, 0, NULL);
}

/* VNCサーバ接続 */
void
JoinVNC () {
  char commandvnc1[MAXBUF];
  char commandvnc2[MAXBUF];
  char commandvnc3[MAXBUF];
  char serverport[10];
  struct in_addr serverip;

  fprintf(stderr, "vncdisplay=%s\n",vncdisplay);
  serverip.s_addr = client_CB.server_ip;
  sprintf (serverport, "%d\0", ntohs(client_CB.server_port));

  //RealVNC
  sprintf (commandvnc1, "winvnc4 -connect %s:%s", (char *)inet_ntoa(serverip), serverport);
  //TightVNC
  sprintf (commandvnc2, "winvnc -connect %s:%s", (char *)inet_ntoa(serverip), serverport);
  //UltraVNC
  sprintf (commandvnc3, "winvnc -connect %s:%s", (char *)inet_ntoa(serverip), serverport);

  /* made sh command */
  fflush (stdout);
  fprintf (stdout, "%s\n", commandvnc1);
  fprintf (stdout, "%s\n", commandvnc2);
  fprintf (stdout, "%s\n", commandvnc3);

  /* execute vncconnect */
  runCommand(commandvnc3, 1, NULL);

  // UltraVNCのwinvncコマンドは接続時に成功or失敗を戻り値で
  // 返さないため、この位置でリトライや戻り値のチェックは行わない

  client_CB.connectstate = STAT_VNC;
}
