////////////////////////////////////////////////////////////////////////////////
/// @file
/// @brief ソケット初期化関連のソース
///
/// ソケット利用のための共通コードを実装しています。
///
/// Copyright (C) 2009 Alpha Systems Inc. All Rights Reserved.
/// @internal
/// @date $Date: $
/// @version $Revision: $
////////////////////////////////////////////////////////////////////////////////

#include <winsock2.h>

#include "vncviewer.h"


/* initialize socket library */
int InitializeSocket(void)
{
	WSADATA wsaData;
	if (WSAStartup (MAKEWORD(2, 2) , &wsaData) == SOCKET_ERROR)
	{
    fprintf(stderr, "%s : InitializeSocket : WSAStartup\n", programName);
    return -1;
	}
	return 0;
}

/* finalize socket library */
int FinalizeSocket(void)
{
  if (WSACleanup () == SOCKET_ERROR)
  {
    fprintf(stderr, "%s : InitializeSocket : WSACleanup\n", programName);
    return -1;
  }
	return 0;
}

/* close socket */
int CloseSocket(int sock)
{
  closesocket(sock);
	return 0;
}
